#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
    FILE *infile1,*infile2;
    FILE *outfile;

    if (argc != 4)
    {
        fprintf(stderr, "interleave words (2-byte) from two files into one\n");
        fprintf(stderr, "usage: interleave infile1 infile2 outfile\n");
        exit(EXIT_FAILURE);
    }

    infile1 = fopen(argv[1], "rb");
    infile2 = fopen(argv[2], "rb");
    outfile = fopen(argv[3], "wb");
    if (!infile1 || !infile2 || !outfile)
    {
        fprintf(stderr, "can't you be bothered to check your command line?\n");
        exit(EXIT_FAILURE);
    }

    while (!feof(infile1) && !feof(infile2))
    {
        char buf[4];
        fread(buf,1,2,infile1);
        fread(buf+2,1,2,infile2);
        if (feof(infile1) || feof(infile2)) break;
        fwrite(buf,1,4,outfile);
    }
    if (!feof(infile1) || !feof(infile2))
    {
        fprintf(stderr, "files didn't end in smae place\n");
        exit(EXIT_FAILURE);
    }

    return 0;
}
